"""
Library to turn URLs into tinyurl.com's
"""

import urllib
import re

#TINYURL_API = r'http://tinyurl.com/api-create.php?url='

TINYURL_API = r'http://is.gd/api.php?longurl='

def tinyurl(url):
    """
    Register URL and return the corresponding tinyurl.com URL
    """
    if url.startswith(r'http://is.gd/'):
        return url
    try:
        return urllib.urlopen(TINYURL_API + urllib.quote(url)).read()
    except:
        return url

def tinyfy_string(string):
    """
    Replaces all regular URLs in a string with tinyurl.com's
    """
    return re.sub(r'https?://[^ ]*', lambda m: tinyurl(m.group()), string)
