# -*- coding: utf-8 -*-

import xmlrpclib
from time import gmtime, strftime
from random import Random
from skypebotconfig import wikiuser, wikipass

class Wiki:
    url = "http://wiki.piratpartiet.se/"
    sp = xmlrpclib.ServerProxy(url + "?action=xmlrpc2", allow_none=True)
    lefthand = '23456qwertasdfgzxcv'
    namelength = 8

    def __init__(self):
        self.token = self.sp.getAuthToken(wikiuser, wikipass)

    def get_multicall(self):
        mc = xmlrpclib.MultiCall(self.sp)
        mc.applyAuthToken(self.token)
        return mc

    def add_wiki_page(self, pagename, content):
        mc = self.get_multicall()
        mc.putPage(pagename, content)

        try:
            success, raw = tuple(mc())
            if success:
                return u'Postat: %s%s' % (self.url, pagename)
            else:
                return u'Fel vid wikipostning: %s' % raw

        except xmlrpclib.Fault, err:
            return u'Abrupt fel vid wikipostning: %s' % err

    def handle_skype_message(self, author, text):
        rnd = Random()
        pagename = 'ppbot/' + ''.join([rnd.choice(self.lefthand) 
                                       for s in range(self.namelength)])
        rows = ['    ' + s.strip() for s in text.split('\n')]
        rows += ["-- '''''%s''''' ''%s''" % (author, strftime("%Y-%m-%d %H:%M:%S", gmtime()))]
        content = '<<BR>>\n'.join(rows)

        return self.add_wiki_page(pagename, content)
